type day = int;;
type month = int;;
type year = int;;
type date = (day * month * year);;
type dayname = int;;

let leap y = if y mod 100 = 0 then (y mod 400 = 0) else (y mod 4 = 0)
let month_lengths y =
 let feb = if leap y then 29 else 28 in
 [31; feb; 31; 30; 31; 30; 31; 31; 30; 31; 30; 31]

let jan1 y =
 let x = y - 1 in
 (365 * x + x / 4 - x / 100 + x / 400 + 1) mod 7

let rec scan_left f e = function
 | [] -> [e]
 | x :: xs -> e :: scan_left f (f e x) xs

let mtotals y = scan_left ( + ) (jan1 y) (month_lengths y)
let first_days y = Lst.take 12 (Lst.map (fun x -> x mod 7) (mtotals y))
let fstday m y = Lst.nth (first_days y) (m - 1)
let day (d, m, y) = (fstday m y + d - 1) mod 7
