let rec split_words wrd = function
  | [] -> (* no more charactors *)
      [wrd]
  | c :: rest ->
    if c = ' ' then (* wrd ends *)
        wrd :: split_words [] rest
    else (* c should be a part of wrd *)
      split_words (wrd @ [c]) rest
;;

let paragraph w justifier =
  let rec make_rows line = function
    | [] -> (* no more words *)
      if line = [] then (* no row to add *)
        []
      else (* make the last row *)
        [Picture.row (justifier w line)]
    | wrd :: words ->
      if line = [] then (* wrd starts a new line *)
        make_rows wrd words
      else if Lst.length line + Lst.length wrd < w then (* wrd fits in this line *)
        make_rows (line @ [' '] @ wrd) words
      else (* needs a new line *)
        Picture.row (justifier w line) :: make_rows [] (wrd::words)
  in
  fun t -> Picture.stack (make_rows [] (split_words [] t))
;;
